diff a/src/hotspot/share/oops/markWord.cpp b/src/hotspot/share/oops/markWord.cpp
--- a/src/hotspot/share/oops/markWord.cpp
+++ b/src/hotspot/share/oops/markWord.cpp
@@ -27,13 +27,13 @@
 #include "runtime/javaThread.hpp"
 #include "runtime/objectMonitor.inline.hpp"
 #include "utilities/ostream.hpp"
 
 #ifdef _LP64
-STATIC_ASSERT(markWord::klass_shift + markWord::klass_bits == 64);
+STATIC_ASSERT(markWord::klass_shift + markWord::klass_bits == 32);
 // The hash (preceding klass bits) shall be a direct neighbor but not interleave
-STATIC_ASSERT(markWord::klass_shift == markWord::hash_bits + markWord::hash_shift);
+STATIC_ASSERT(markWord::klass_shift == markWord::hashctrl_bits + markWord::hashctrl_shift);
 #endif
 
 markWord markWord::displaced_mark_helper() const {
   assert(has_displaced_mark_helper(), "check");
   if (has_monitor()) {
@@ -88,10 +88,13 @@
     st->print(" mark(");
     if (is_unlocked()) {   // last bits = 01
       st->print("is_unlocked");
       if (has_no_hash()) {
         st->print(" no_hash");
+      } else if (UseCompactObjectHeaders) {
+        st->print(" hash is-hashed=%s is-copied=%s", BOOL_TO_STR(is_hashed_not_expanded()), BOOL_TO_STR(
+                is_hashed_expanded()));
       } else {
         st->print(" hash=" INTPTR_FORMAT, hash());
       }
     } else {
       st->print("??");
